import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.awt.Image.*;
import java.net.*;

// Skyd P lreren: Java Applet eksempel med Images og lidt Animation. ow. feb. 2005

public class SkydPaaLaererenApplet extends Applet {
  Color color;
  int width,height;
  static final int R=5, D=2*R, ndt=0;
  static final double g=9.82, DT=0.2;
  double phi=0,v0,x0,y0,vx0,vy0,t,x,y,xmin=0,xmax=600,ymin=0,ymax=400;
  Label vinkelLabel,fartLabel;
  TextField vinkelTextField,fartTextField;
  static Image owImage,kanonImage,forbierImage,avImage, blankImage;
	static MediaTracker mediaTracker;
  static int owImageID=0,kanonImageID=1,blankImageID=4,forbierImageID=2,avImageID=3;
  static int xpixow,ypixow,owHeight,owWidth;
  boolean started=false, hit,forbier;

  public void init() {
		owImage = getImage(getDocumentBase(),"ow53.jpg");
		kanonImage = getImage(getDocumentBase(),"kanon.jpg");
		avImage = getImage(getDocumentBase(),"av.jpg");
		forbierImage = getImage(getDocumentBase(),"forbier.jpg");
		blankImage = getImage(getDocumentBase(),"blank.jpg");

		mediaTracker = new MediaTracker(this);
		mediaTracker.addImage(owImage,owImageID);
		mediaTracker.addImage(forbierImage,forbierImageID);
		mediaTracker.addImage(blankImage,blankImageID);
		mediaTracker.addImage(avImage,avImageID);
		mediaTracker.addImage(kanonImage,kanonImageID);
		try {
			mediaTracker.waitForID(owImageID);
			mediaTracker.waitForID(forbierImageID);
			mediaTracker.waitForID(avImageID);
			mediaTracker.waitForID(kanonImageID);
			mediaTracker.waitForID(blankImageID);
		}
		catch (InterruptedException e) {
		}
    width=getBounds().width;
    height=getBounds().height;
    hit=false; forbier=false;
    t=0;
    if (!started) {
			started=true;
			vinkelLabel = new Label("Elevation (grader)");
			fartLabel = new Label("Fart (m/s)");
			vinkelTextField = new TextField(5);
			fartTextField = new TextField(5);
			Button skydButton = new Button("Skyd");
			add(fartLabel);
			add(fartTextField);
			add(vinkelLabel);
			add(vinkelTextField);
			add(skydButton);
			SkudListener skudListener = new SkudListener(fartTextField,vinkelTextField,skydButton);
			fartTextField.addActionListener(skudListener);
			vinkelTextField.addActionListener(skudListener);
			skydButton.addActionListener(skudListener);
		}
  }

	public void paint(Graphics graphics) {
		if (!hit && !forbier) {
			owWidth=owImage.getWidth(this);
			owHeight=owImage.getHeight(this);
			int kanonWidth=kanonImage.getWidth(this);
			int kanonHeight=kanonImage.getHeight(this);
			x0=0.7*xkoor(kanonWidth);
			y0=0.7*ykoor(height-kanonHeight);
			graphics.setColor(Color.white);
			graphics.fillRect(0,30,width,height);
			xpixow=width-owWidth;
			ypixow=30+(int)((1-Math.random())*(height-owHeight-30));
			if (kanonImage!=null) graphics.drawImage(kanonImage,0,height-kanonHeight,this);
			if (owImage!=null) graphics.drawImage(owImage,xpixow,ypixow,this);
			graphics.setColor(Color.black);
			graphics.drawRect(1,1,width-2,height-2);
		}
		else {
			if (!hit) playAudioClip("forbier.au"); else playAudioClip("hitme.au");
			int delx=100,dely;
			if (ypixow<80) dely=0;
			else
			  if (ypixow<130) dely=50;
			  else dely=130;
			if (!hit) {
				if (forbierImage!=null)
					graphics.drawImage(forbierImage,xpixow-delx,ypixow-dely,this);
					delay(3000);
				if (blankImage!=null)
					graphics.drawImage(blankImage,xpixow-delx,ypixow-dely,this);
			}
			else {
				if (avImage!=null)
					graphics.drawImage(avImage,xpixow-delx,ypixow-dely,this);
					delay(3000);
				if (blankImage!=null)
				graphics.drawImage(blankImage,xpixow-delx,ypixow-dely,this);
			}
	  }
	}

  public int xpix(double xkoor) {
		return (int) ((xkoor-xmin)/(xmax-xmin)*width);
	}

  public int ypix(double ykoor) {
		return (int) ((1-(ykoor-ymin)/(ymax-ymin))*height);
	}

  public double xkoor(int xpix) {
		return xmin+(xmax-xmin)*((double)xpix/(double)width);
	}

  public double ykoor(int ypix) {
			return ymin+(ymax-ymin)*(1-(double)ypix/(double)height);
  }

  private void delay (int ms) {
    try {
      Thread.sleep(ms);
    }
    catch (Exception ignored) {
    }
  }
   public void playAudioClip(String audioFilename) {

		 try {
			 //URL url = new URL("file", "localhost", audioFilename);
			 URL url = new URL(getDocumentBase(), audioFilename);
         AudioClip audioClip = Applet.newAudioClip(url);
         audioClip.play();
     }
      catch(Exception e) {
         System.out.println("Can't open " + audioFilename);
      }
   }

  class SkudListener implements ActionListener {
    private Button skydButton;
    private TextField fartTextField,vinkelTextField;
    SkudListener(TextField fartTextField,TextField vinkelTextField,Button skydButton) {
      this.fartTextField = fartTextField;
      this.vinkelTextField = vinkelTextField;
      this.skydButton = skydButton;
    }
    public boolean youHitMe() {
			return (xpix(x)>xpixow) && (xpix(x)<xpixow+owWidth) && (ypix(y)>ypixow) && (ypix(y)<ypixow+owHeight);
		}

    public void actionPerformed(ActionEvent actionEvent) {
      Graphics graphics;
      if (actionEvent.getActionCommand().equals("Skyd")) {
				if (started) init();
				x=x0; y=y0;
				v0=Double.parseDouble(fartTextField.getText().trim());
				phi = Math.PI/180*Double.parseDouble(vinkelTextField.getText().trim());
				vx0=v0*Math.cos(phi);
				vy0=v0*Math.sin(phi);
				playAudioClip("fire.au");
				while ((y>ymin) && (x>xmin) && (x<xmax-R)) {
					graphics = getGraphics();
          color=Color.black;
          graphics.setColor(color);
          graphics.fillOval(xpix(x)-R,ypix(y)-R,D,D);
          if(!hit) hit=youHitMe();
          if(!hit) forbier=true;
          delay(60);
          color=Color.white;
          graphics.setColor(color);
          graphics.fillOval(xpix(x)-R,ypix(y)-R,D,D);
          if ((int)(t/(10*DT))>=ndt) {
						color=Color.gray;
						graphics.setColor(color);
						graphics.fillOval(xpix(x)-1,ypix(y)-1,2,2);
				  }
          t=t+DT;
          x=x0+vx0*t;
          y=y0+vy0*t-0.5*g*t*t;
				}

				graphics = getGraphics();
				paint(graphics);
			}
    }
  }
}
