package rtl;
import java.io.*;

public class TextFileRead {
    boolean endOfFile=false, endOfLine=false, firstChar=true;
    char nextChar='$';
    String line;
    BufferedReader in;
    PrintWriter out;

    public TextFileRead(String filename) {
    try {
      in = new BufferedReader(new FileReader(filename));
    }
    catch (FileNotFoundException fileNotFoundException) {
      System.out.println("TextFileRead: "+fileNotFoundException);
      try {
        out = new PrintWriter(new FileWriter(filename));
      }
      catch (IOException ioException) {
        System.out.println("TextFileRead: "+ioException);
      }
      out.close();
      try {
        in = new BufferedReader(new FileReader(filename));
      }
      catch (FileNotFoundException e) {
        System.out.println("TextFileRead: "+e);
      }
    }
  }

    public String readLine()  {
    try {
      line=in.readLine();
      endOfFile=line.equals(null);
      return line;
    }
    catch (IOException e) {
      System.out.println("TextFileRead: "+e);
      endOfFile=true;
      return "";
    }
    catch (NullPointerException e) {
      endOfFile=true;
      return "";
    }
  }

  public char readChar()  {
    char ch='$';
    int inRead;
    try {
      if (firstChar) {
        firstChar=false;
        inRead = in.read();
        if (inRead !=-1) {
          ch = (char)inRead;
          inRead = in.read();
          nextChar = (char)inRead;
        }
        else endOfFile=true;
      }
      else {
        ch = nextChar;
        inRead = in.read();
        if(inRead==10) {
          endOfLine=true;
          inRead = in.read();
        }
      }
      if (inRead != -1) nextChar = (char)inRead;
      else endOfFile=true;
      return ch;
    }
    catch (IOException e) {
      System.out.println("TextFileRead: "+e);
      return ch;
    }
  }

  public boolean eoln() {
    if (!endOfLine) return endOfLine;
    else {
      endOfLine=false;
      return true;
    }
  }

  public boolean eof() {
    return endOfFile;
  }

  public void close() {
    try {
      in.close();
    }
    catch (IOException e) {
          System.out.println("TextFileRead: "+e);
    }
  }
}

